Bug 16909 - [4.0 Regression] "unrecognizable insn" ICE during bootstrap with-cpu=nocona
Summary: [4.0 Regression] "unrecognizable insn" ICE during bootstrap with-cpu=nocona
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: target (show other bugs)
Version: 4.0.0
: P2 normal
Target Milestone: 4.0.0
Assignee: Jakub Jelinek
URL:
Keywords: build, ice-on-valid-code
Depends on:
Blocks:
 
Reported: 2004-08-06 23:56 UTC by H.J. Lu
Modified: 2005-07-23 22:49 UTC (History)
1 user (show)

See Also:
Host: x86_64-unknown-linux-gnu
Target: x86_64-unknown-linux-gnu
Build: x86_64-unknown-linux-gnu
Known to work:
Known to fail:
Last reconfirmed:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description H.J. Lu 2004-08-06 23:56:05 UTC
As of Fri Aug  6 23:36:29 UTC 2004, I got

/net/gnu/export/gnu/src/gcc/gcc/gcc/bitmap.c: In function `bitmap_equal_p':
/net/gnu/export/gnu/src/gcc/gcc/gcc/bitmap.c:679: error: unrecognizable insn:
(insn:HI 15 14 17 0 /net/gnu/export/gnu/src/gcc/gcc/gcc/bitmap.c:674 (parallel [
           (set (mem/s:DI (reg/f:DI 78) [18 c+16 S8 A128])
                (reg:DI 68))
            (set (reg/f:DI 79)
                (plus:DI (reg/f:DI 78)
                    (const_int 8 [0x8])))
            (use (reg:SI 19 dirflag))
        ]) -1 (insn_list 14 (nil))
    (expr_list:REG_DEAD (reg:SI 19 dirflag)
        (expr_list:REG_DEAD (reg:DI 68)
            (expr_list:REG_DEAD (reg/f:DI 78)
                (expr_list:REG_UNUSED (reg/f:DI 79)
                    (nil))))))
/net/gnu/export/gnu/src/gcc/gcc/gcc/bitmap.c:679: internal compiler error: in
extract_insn, at recog.c:2040
Please submit a full bug report,
with preprocessed source if appropriate.
See <URL:http://gcc.gnu.org/bugs.html> for instructions.
make[4]: *** [bitmap.o] Error 1
make[4]: *** Waiting for unfinished jobs....
make[4]: Leaving directory `/export/build/gnu/gcc/build-x86_64-linux/gcc'
make[3]: *** [stage2_build] Error 2
make[3]: Leaving directory `/export/build/gnu/gcc/build-x86_64-linux/gcc'
make[2]: *** [bootstrap] Error 2
Comment 1 Andrew Pinski 2004-08-07 00:20:49 UTC
It is always nice to add the preprocessed source as others without access to your target can fix the bug.
Comment 2 H.J. Lu 2004-08-07 01:37:55 UTC
[hjl@gnu-20 gcc]$ cat foo.c
typedef struct bitmap_head_def {
  void *first;
  void *current;
  unsigned int indx;
  int using_obstack;
} bitmap_head;

bitmap_head c;

void
bitmap_equal_p ()
{
  memset (&c, 0, sizeof (c));
}
[hjl@gnu-20 gcc]$ stage1/xgcc -Bstage1/ -O2 -S foo.c
foo.c: In function `bitmap_equal_p':
foo.c:13: warning: incompatible implicit declaration of built-in 
function 'memset'
foo.c:14: error: unrecognizable insn:
(insn:HI 17 16 18 0 (parallel [
            (set (mem/s:DI (reg/f:DI 62) [2 c+16 S8 A64])
                (reg:DI 60))
            (set (reg/f:DI 63)
                (plus:DI (reg/f:DI 62)
                    (const_int 8 [0x8])))
            (use (reg:SI 19 dirflag))
        ]) -1 (insn_list 16 (nil))
    (expr_list:REG_DEAD (reg:SI 19 dirflag)
        (expr_list:REG_DEAD (reg:DI 60)
            (expr_list:REG_DEAD (reg/f:DI 62)
                (expr_list:REG_UNUSED (reg/f:DI 63)
                    (nil))))))
foo.c:14: internal compiler error: in extract_insn, at recog.c:2040
Please submit a full bug report,
with preprocessed source if appropriate.
See <URL:http://gcc.gnu.org/bugs.html> for instructions.

See

http://gcc.gnu.org/ml/gcc/2004-08/msg00247.html
Comment 3 Andrew Pinski 2004-08-07 16:41:35 UTC
Fixed.
Comment 4 H.J. Lu 2004-08-07 17:36:38 UTC
It isn't fixed.
Comment 6 H.J. Lu 2004-08-08 06:50:42 UTC
You need to configure gcc with "--with-cpu=nocona" to see the bug.
Comment 7 CVS Commits 2004-08-10 21:40:08 UTC
Subject: Bug 16909

CVSROOT:	/cvs/gcc
Module name:	gcc
Changes by:	hjl@gcc.gnu.org	2004-08-10 21:40:04

Modified files:
	gcc            : ChangeLog 
	gcc/config/i386: i386.md 

Log message:
	2004-08-10  H.J. Lu  <hongjiu.lu@intel.com>
	
	PR target/16909
	* config/i386/i386.md (*strsetdi_rex_1): Use DI instead of SI.

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/ChangeLog.diff?cvsroot=gcc&r1=2.4853&r2=2.4854
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/config/i386/i386.md.diff?cvsroot=gcc&r1=1.552&r2=1.553

Comment 8 Andrew Pinski 2004-08-10 21:42:24 UTC
Fixed.